

	SECTION	IT11_Replay,CODE
	OPT	C-,O+
	
init
	move.l	$80.w,oldtrap
	move.l	#start,$80.w
	trap	#0
	move.l	oldtrap,$80.w
	clr.l	d0
	rts

start	move.w	#$2700,sr
	
	bsr	it_init
	
loopA	move.l	$dff004,d0
	andi.l	#$ff00,d0
	cmpi.l	#$4000,d0
	bne.s	loopA
	move.w	#$f00,$dff180
	bsr	it_musicA
	move.w	#$000,$dff180
	
loopB	move.l	$dff004,d0
	andi.l	#$ff00,d0
	cmpi.l	#$6000,d0
	bne.s	loopB
	move.w	#$0f0,$dff180
	bsr	it_musicB
	move.w	#$000,$dff180

loopC	move.l	$dff004,d0
	andi.l	#$ff00,d0
	cmpi.l	#$8000,d0
	bne.s	loopC
	move.w	#$00f,$dff180
	bsr	it_musicC
	move.w	#$000,$dff180

	btst	#6,$bfe001
	bne	loopA
	
	bsr	it_end
	rte

oldtrap	dl	0

	* * * * * * * * * * * * * * * * *
	* IceTracker v1.1 - Fast Replay *
	*  Uses Registers: d0-d7/a0-a6  *
	*        (c)Icepic 1993         *
	* * * * * * * * * * * * * * * * *
	* jsr  it_init    ; init replay *
	* jsr  it_musicA  ; every vbl a *
	* jsr  it_musicB  ; every vbl b *
	* jsr  it_musicC  ; every vbl c *
	* jsr  it_end     ; end replay  *
	* * * * * * * * * * * * * * * * *
	* This replay routine is highly *
	* optimised as all delays have  *
	* been removed. It is therefore *
	* required that you leave some  *
	* delay between the it_musicX   *
	* calls as this replay doesn't! *
	* * * * * * * * * * * * * * * * *
	
it_musicB
	move.b	it_counter(pc),d0
	bne.s	it_rts
	move.w	it_dmacon(pc),d0
	ori.w	#$8000,d0
	move.w	d0,$dff096
it_rts	rts

it_musicC
	move.b	it_counter(pc),d0
	bne.s	it_rts
	bsr	it_1ca
	rts

it_init	lea	it_data,a0
	lea	$3b8(a0),a1
	move.w	#$1ff,d0
	moveq	#0,d1
it_lop2	cmp.b	0(a1,d0.w),d1
	bhi.s	it_lop
	move.b	0(a1,d0.w),d1
it_lop	dbra	d0,it_lop2
	addq.b	#1,d1
	lea	it_samplestart(pc),a1
	lsl.l	#8,d1
	lea	0(a0,d1.l),a2
	lea	$5bc(a2),a2
	moveq	#$1e,d0
it_lop3	clr.l	(a2)
	move.l	a2,(a1)+
	moveq	#0,d1
	move.w	$2a(a0),d1
	add.l	d1,d1
	adda.l	d1,a2
	adda.w	#$1e,a0
	dbra	d0,it_lop3
	bset	#1,$bfe001
	move.b	#6,it_speed
	lea	it_voice1(pc),a0
	move.w	#1,$14(a0)
	lea	it_voice2(pc),a0
	move.w	#2,$14(a0)
	lea	it_voice3(pc),a0
	move.w	#4,$14(a0)
	lea	it_voice4(pc),a0
	move.w	#8,$14(a0)
	bsr.s	it_end
	clr.b	it_songpos
	clr.b	it_counter
	clr.w	it_pattpos
	bsr	it_184
	rts

it_end	lea	$dff0a8,a0
	moveq	#0,d0
	move.w	d0,(a0)
	move.w	d0,$10(a0)
	move.w	d0,$20(a0)
	move.w	d0,$30(a0)
	rts

it_musicA
	lea	it_data,a0
	addq.b	#1,it_counter
	move.b	it_counter,d0
	cmp.b	it_speed,d0
	blt.s	it_nonew
	clr.b	it_counter
	bra	it_184

it_nonew
	lea	it_voice1(pc),a6
	lea	$dff0a0,a5
	bsr	it_com
	lea	it_voice2(pc),a6
	lea	$dff0b0,a5
	bsr	it_com
	lea	it_voice3(pc),a6
	lea	$dff0c0,a5
	bsr	it_com
	lea	it_voice4(pc),a6
	lea	$dff0d0,a5
	bsr	it_com
	bra	it_exit

it_12e	moveq	#0,d0
	move.b	it_counter,d0
	divu.w	#3,d0
	swap	d0
	tst.w	d0
	beq.s	it_15a
	cmpi.w	#2,d0
	beq.s	it_14e
	moveq	#0,d0
	move.b	3(a6),d0
	lsr.b	#4,d0
	bra.s	it_160

it_14e	moveq	#0,d0
	move.b	3(a6),d0
	andi.b	#15,d0
	bra.s	it_160

it_15a	move.w	$10(a6),d2
	bra.s	it_17e

it_160	add.w	d0,d0
	moveq	#0,d1
	move.w	$10(a6),d1
	lea	it_periods(pc),a0
	moveq	#$24,d3
it_16e	move.w	0(a0,d0.w),d2
	cmp.w	(a0),d1
	bge.s	it_17e
	addq.l	#2,a0
	dbra	d3,it_16e
	rts

it_17e	move.w	d2,6(a5)
	rts

it_184	clr.w	it_dmacon
	lea	$dff0a0,a5
	lea	it_voice1(pc),a6
	moveq	#0,d5
	bsr	it_24a
	lea	$dff0b0,a5
	lea	it_voice2(pc),a6
	moveq	#1,d5
	bsr	it_24a
	lea	$dff0c0,a5
	lea	it_voice3(pc),a6
	moveq	#2,d5
	bsr	it_24a
	lea	$dff0d0,a5
	lea	it_voice4(pc),a6
	moveq	#3,d5
	bsr	it_24a
	rts

it_1ca	lea	$dff000,a5
	lea	it_voice4(pc),a6
	move.l	$a(a6),$d0(a5)
	move.w	$e(a6),$d4(a5)
	lea	it_voice3(pc),a6
	move.l	$a(a6),$c0(a5)
	move.w	$e(a6),$c4(a5)
	lea	it_voice2(pc),a6
	move.l	$a(a6),$b0(a5)
	move.w	$e(a6),$b4(a5)
	lea	it_voice1(pc),a6
	move.l	$a(a6),$a0(a5)
	move.w	$e(a6),$a4(a5)
	addq.w	#4,it_pattpos
	cmpi.w	#$100,it_pattpos
	bne.s	it_exit
it_220	clr.w	it_pattpos
	clr.b	it_break
	addq.b	#1,it_songpos
	andi.b	#$7f,it_songpos
	move.b	it_songpos,d1
	lea	it_data,a0
	cmp.b	$3b6(a0),d1
	bne.s	it_exit
	clr.b	it_songpos
it_exit	tst.b	it_break
	bne.s	it_220
	rts

it_24a	lea	it_data,a0
	lea	$c(a0),a3
	lea	$3b8(a0),a2
	lea	$5bc(a0),a0
	moveq	#0,d0
	moveq	#0,d1
	move.b	it_songpos,d0
	lsl.w	#2,d0
	adda.w	d0,a2
	move.b	0(a2,d5.w),d1
	lsl.l	#8,d1
	add.w	it_pattpos,d1
	move.l	0(a0,d1.l),(a6)
	addq.l	#4,d1
	moveq	#0,d2
	move.b	2(a6),d2
	andi.b	#$f0,d2
	lsr.b	#4,d2
	move.b	(a6),d0
	andi.b	#$f0,d0
	or.b	d0,d2
	tst.b	d2
	beq.s	it_2f2
	moveq	#0,d3
	lea	it_samplestart(pc),a1
	move.l	d2,d4
	subq.l	#1,d2
	lsl.l	#2,d2
	mulu.w	#$1e,d4
	move.l	0(a1,d2.l),4(a6)
	move.w	0(a3,d4.l),8(a6)
	move.w	2(a3,d4.l),$12(a6)
	move.w	4(a3,d4.l),d3
	tst.w	d3
	beq.s	it_2dc
	move.l	4(a6),d2
	add.w	d3,d3
	add.l	d3,d2
	move.l	d2,$a(a6)
	move.w	4(a3,d4.l),d0
	add.w	6(a3,d4.l),d0
	move.w	d0,8(a6)
	move.w	6(a3,d4.l),$e(a6)
	move.w	$12(a6),8(a5)
	bra.s	it_2f2

it_2dc	move.l	4(a6),d2
	add.l	d3,d2
	move.l	d2,$a(a6)
	move.w	6(a3,d4.l),$e(a6)
	move.w	$12(a6),8(a5)
it_2f2	move.w	(a6),d0
	andi.w	#$fff,d0
	beq	it_50ei
	move.b	2(a6),d0
	andi.b	#15,d0
	cmpi.b	#3,d0
	bne.s	it_310
	bsr.s	it_348
	bra	it_50ei

it_310	move.w	(a6),$10(a6)
	andi.w	#$fff,$10(a6)
	move.w	$14(a6),$dff096
	clr.b	$1b(a6)
	move.l	4(a6),(a5)
	move.w	8(a6),4(a5)
	move.w	$10(a6),d0
	andi.w	#$fff,d0
	move.w	d0,6(a5)
	move.w	$14(a6),d0
	or.w	d0,it_dmacon
	bra	it_50ei

it_348	move.w	(a6),d2
	andi.w	#$fff,d2
	move.w	d2,$18(a6)
	move.w	$10(a6),d0
	clr.b	$16(a6)
	cmp.w	d0,d2
	beq.s	it_368
	bge.s	it_36c
	move.b	#1,$16(a6)
	rts

it_368	clr.w	$18(a6)
it_36c	rts

it_36e	move.b	3(a6),d0
	beq.s	it_37c
	move.b	d0,$17(a6)
	clr.b	3(a6)
it_37c	tst.w	$18(a6)
	beq.s	it_36c
	moveq	#0,d0
	move.b	$17(a6),d0
	tst.b	$16(a6)
	bne.s	it_3ae
	add.w	d0,$10(a6)
	move.w	$18(a6),d0
	cmp.w	$10(a6),d0
	bgt.s	it_3a6
	move.w	$18(a6),$10(a6)
	clr.w	$18(a6)
it_3a6	move.w	$10(a6),6(a5)
	rts

it_3ae	sub.w	d0,$10(a6)
	move.w	$18(a6),d0
	cmp.w	$10(a6),d0
	blt.s	it_3a6
	move.w	$18(a6),$10(a6)
	clr.w	$18(a6)
	move.w	$10(a6),6(a5)
	rts

it_3ce	move.b	3(a6),d0
	beq.s	it_3d8
	move.b	d0,$1a(a6)
it_3d8	move.b	$1b(a6),d0
	lea	it_sin(pc),a0
	lsr.w	#2,d0
	andi.w	#$1f,d0
	moveq	#0,d2
	move.b	0(a0,d0.w),d2
	move.b	$1a(a6),d0
	andi.w	#15,d0
	mulu.w	d0,d2
	lsr.w	#6,d2
	move.w	$10(a6),d0
	tst.b	$1b(a6)
	bmi.s	it_406
	add.w	d2,d0
	bra.s	it_408

it_406	sub.w	d2,d0
it_408	move.w	d0,6(a5)
	move.b	$1a(a6),d0
	lsr.w	#2,d0
	andi.w	#$3c,d0
	add.b	d0,$1b(a6)
	rts

it_41c	move.w	$10(a6),6(a5)
	rts

it_com	move.w	2(a6),d0
	andi.w	#$fff,d0
	beq.s	it_41c
	move.b	2(a6),d0
	andi.b	#$f,d0
	tst.b	d0
	beq	it_12e
	cmpi.b	#1,d0
	beq	it_4aa
	cmpi.b	#2,d0
	beq	it_4dc
	cmpi.b	#3,d0
	beq	it_36e
	cmpi.b	#4,d0
	beq	it_3ce
	cmpi.b	#5,d0
	beq	tonevol	
	cmpi.b	#6,d0
	beq	vibratovol
	cmpi.b	#7,d0
	beq	tremolo
	move.w	$10(a6),6(a5)
	cmpi.b	#$a,d0
	beq.s	it_468
	rts

vibratovol
	bsr	vibrato

it_468	moveq	#0,d0
	move.b	3(a6),d0
	lsr.b	#4,d0
	tst.b	d0
	beq.s	it_48e
	add.w	d0,$12(a6)
	cmpi.w	#$40,$12(a6)
	bmi.s	it_486
	move.w	#$40,$12(a6)
it_486	move.w	$12(a6),8(a5)
	rts

it_48e	moveq	#0,d0
	move.b	3(a6),d0
	andi.b	#$f,d0
	sub.w	d0,$12(a6)
	bpl.s	it_4a2
	clr.w	$12(a6)
it_4a2	move.w	$12(a6),8(a5)
	rts

it_4aa	moveq	#0,d0
	move.b	3(a6),d0
	sub.w	d0,$10(a6)
	move.w	$10(a6),d0
	andi.w	#$fff,d0
	cmpi.w	#$71,d0
	bpl.s	it_4ce
	andi.w	#$f000,$10(a6)
	ori.w	#$71,$10(a6)
it_4ce	move.w	$10(a6),d0
	andi.w	#$fff,d0
	move.w	d0,6(a5)
	rts

it_4dc	moveq	#0,d0
	move.b	3(a6),d0
	add.w	d0,$10(a6)
	move.w	$10(a6),d0
	andi.w	#$fff,d0
	cmpi.w	#$358,d0
	bmi.s	it_500
	andi.w	#$f000,$10(a6)
	ori.w	#$358,$10(a6)
it_500	move.w	$10(a6),d0
	andi.w	#$fff,d0
	move.w	d0,6(a5)
	rts

it_50ei	move.b	2(a6),d0
	andi.b	#$f,d0
	cmp.b	#$e,d0
	beq	it_e_commands
	cmpi.b	#$d,d0
	beq.s	it_530i
	cmpi.b	#$b,d0
	beq.s	it_536i
	cmpi.b	#$c,d0
	beq.s	it_546
	cmpi.b	#$f,d0
	beq.s	it_55c
	rts

it_530i	st	it_break
	rts

it_536i	move.b	3(a6),d0
	subq.b	#1,d0
	move.b	d0,it_songpos
	st	it_break
	rts

it_546	cmpi.b	#$40,3(a6)
	ble.s	it_554
	move.b	#$40,3(a6)
it_554	move.b	3(a6),8(a5)
	rts

it_55c	move.b	3(a6),d0
	andi.b	#$1f,d0
	beq.s	it_56e
	clr.b	it_counter
	move.b	d0,it_speed
it_56e	rts

tremolo
	move.b	3(a6),d0
	beq.s	it_tremolo2
	move.b	$1c(a6),d2
	and.b	#$f,d0
	beq.s	it_treskip
	and.b	#$f0,d2
	or.b	d0,d2
it_treskip
	move.b	3(a6),d0
	and.b	#$f0,d0
	beq.s	it_treskip2
	and.b	#$0f,d2
	or.b	d0,d2
it_treskip2
	move.b	d2,$1c(a6)
it_tremolo2
	move.b	$1d(a6),d0
	lea	it_sin(pc),a4
	lsr.w	#2,d0
	and.w	#$1f,d0
	moveq	#0,d2
	move.b	$1e(a6),d2
	lsr.b	#4,d2
	and.b	#$03,d2
	beq.s	it_tre_sine
	lsl.b	#3,d0
	cmp.b	#1,d2
	beq.s	it_tre_rampdown
	move.b	#255,d2
	bra.s	it_tre_set
it_tre_rampdown
	tst.b	$27(a6)
	bpl.s	it_tre_rampdown2
	move.b	#255,d2
	sub.b	d0,d2
	bra.s	it_tre_set
it_tre_rampdown2
	move.b	d0,d2
	bra.s	it_tre_set
it_tre_sine
	move.b	0(a4,d0.w),d2
it_tre_set
	move.b	$1c(a6),d0
	and.w	#$f,d0
	mulu	d0,d2
	lsr.w	#6,d2
	moveq	#0,d0
	move.b	$13(a6),d0
	tst.b	$1d(a6)
	bmi.s	it_tremoloneg
	add.w	d2,d0
	bra.s	it_tremolo3
it_tremoloneg
	sub.w	d2,d0
it_tremolo3
	bpl.s	it_tremoloskip
	moveq	#0,d0
it_tremoloskip
	cmp.w	#$40,d0
	bls.s	it_tremolook
	move.w	#$40,d0
it_tremolook
	move.w	d0,8(a5)
	move.b	$1c(a6),d0
	lsr.w	#2,d0
	and.w	#$003c,d0
	add.b	d0,$1d(a6)
	rts

tonevol
	bsr.s	lbc006336
	bra	it_468

lbc006328
	move.b	3(a6),d0
	beq.s	lbc006336
	move.b	d0,$17(a6)
	clr.b	3(a6)
lbc006336
	tst.w	$18(a6)
	beq.s	lbc006326
	moveq	#0,d0
	move.b	$17(a6),d0
	tst.b	$16(a6)
	bne.s	lbc006368
	add.w	d0,$10(a6)
	move.w	$18(a6),d0
	cmp.w	$10(a6),d0
	bgt.s	lbc006360
	move.w	$18(a6),$10(a6)
	clr.w	$18(a6)
lbc006360
	move.w	$10(a6),6(a5)
lbc006326
	rts

lbc006368
	sub.w	d0,$10(a6)
	move.w	$18(a6),d0
	cmp.w	$10(a6),d0
	blt.s	lbc006360
	move.w	$18(a6),$10(a6)
	clr.w	$18(a6)
	move.w	$10(a6),6(a5)
	rts

vibrato
	move.l	a4,-(sp)
	move.b	3(a6),d0
	beq.s	lbc006394
	move.b	d0,$1a(a6)
lbc006394
	move.b	$1b(a6),d0
	lea	it_sin(pc),a4
	lsr.w	#2,d0
	and.w	#$1f,d0
	moveq	#0,d2
	move.b	0(a4,d0.w),d2
	move.b	$1a(a6),d0
	and.w	#$f,d0
	mulu	d0,d2
	lsr.w	#6,d2
	move.w	$10(a6),d0
	tst.b	$1b(a6)
	bmi.s	lbc0063c2
	add.w	d2,d0
	bra.s	lbc0063c4
lbc0063c2
	sub.w	d2,d0
lbc0063c4
	move.w	d0,6(a5)
	move.b	$1a(a6),d0
	lsr.w	#2,d0
	and.w	#$3c,d0
	add.b	d0,$1b(a6)
	move.l	(sp)+,a4
	rts

it_e_commands
	move.b	3(a6),d0
	and.b	#$f0,d0
	lsr.b	#4,d0
	beq.s	it_filteronoff
	cmp.b	#$f,d0
	beq	it_funkit
it_return2
	rts

it_filteronoff
	move.b	$3(a6),d0
	and.b	#1,d0
	asl.b	#1,d0
	and.b	#$fd,$bfe001
	or.b	d0,$bfe001
	rts	

it_funkit
	tst.b	it_counter
	bne	it_return2
	move.b	$3(a6),d0
	and.b	#$0f,d0
	lsl.b	#4,d0
	and.b	#$0f,$1f(a6)
	or.b	d0,$1f(a6)
	tst.b	d0
	beq	it_return2
it_updatefunk
	movem.l	a0/d1,-(sp)
	moveq	#0,d0
	move.b	$1f(a6),d0
	lsr.b	#4,d0
	beq.s	it_funkend
	lea	it_funktable(pc),a0
	move.b	(a0,d0.w),d0
	add.b	d0,$23(a6)
	btst	#7,$23(a6)
	beq.s	it_funkend
	clr.b	$23(a6)

	move.l	$a(a6),d0
	moveq	#0,d1
	move.w	$e(a6),d1
	add.l	d1,d0
	add.l	d1,d0
	move.l	$24(a6),a0
	addq.l	#1,a0
	cmp.l	d0,a0
	blo.s	it_funkok
	move.l	$a(a6),a0
it_funkok
	move.l	a0,$24(a6)
	moveq	#-1,d0
	sub.b	(a0),d0
	move.b	d0,(a0)
it_funkend
	movem.l	(sp)+,a0/d1
	rts


it_funktable
	db 	$0,$5,$6,$7,$8,$a,$b,$d,$10,$13,$16,$1a,$20,$2b,$40,$80

it_sin	db	$00,$18,$31,$4a,$61,$78,$8d,$a1,$b4,$c5,$d4,$e0,$eb,$f4,$fa,$fd
	db	$ff,$fd,$fa,$f4,$eb,$e0,$d4,$c5,$b4,$a1,$8d,$78,$61,$4a,$31,$18
	
it_periods
	dw	$0358,$0328,$02fa,$02d0,$02a6,$0280,$025c,$023a,$021a,$01fc,$01e0
	dw	$01c5,$01ac,$0194,$017d,$0168,$0153,$0140,$012e,$011d,$010d,$00fe
	dw	$00f0,$00e2,$00d6,$00ca,$00be,$00b4,$00aa,$00a0,$0097,$008f,$0087
	dw	$007f,$0078,$0071,$0000

it_dmacon	dw	0
it_pattpos	dw	0
it_songpos	db	0
it_counter	db	0
it_speed	db	0
it_break	db	0
	
it_samplestart
	dcb.l	$1f,0

it_voice1	dcb.l	$20,0
it_voice2	dcb.l	$20,0
it_voice3	dcb.l	$20,0
it_voice4	dcb.l	$20,0

it_data	incbin	st-00:modules/mod.music

	end

	
